import { StoreObject } from './storeObject';
import { Location } from '../../memory/location';
import { IStoreValue } from './istore_value';

export class StoreObjectRef extends StoreObject {

  private refObj: String;

  /**
   * 
   * @param {StoreObject} stoValue 
   */
  constructor (stoValue: IStoreValue, loc_address: number) {
    super(stoValue.type, loc_address, false);
    this.refObj = stoValue.id!;
  }

  get isRef () {
    return true;
  }

  getRefObj (): String {
    return this.refObj;
  }

  destroy () {
    return false;
  }
}